Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 80264 - strace -f breaks WNOHANG
Summary: strace -f breaks WNOHANG
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 2.1
Classification: Red Hat
Component: strace
Version: 2.1
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Roland McGrath
QA Contact: Brian Brock
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2002-12-23 16:29 UTC by Mike Gahagan
Modified: 2007-11-30 22:06 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2003-01-10 23:07:04 UTC


Attachments (Terms of Use)
tarball of strace output and ksh test script. (deleted)
2002-12-23 16:33 UTC, Mike Gahagan
no flags Details
strace-4.4.cvs20021221rh-1 on 8.0 (deleted)
2002-12-23 18:07 UTC, Mike Gahagan
no flags Details
tarball showing failure with strace-4.4.cvs20021221rh-1 (deleted)
2002-12-23 18:09 UTC, Mike Gahagan
no flags Details


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2003:294 normal SHIPPED_LIVE New strace package fixes numerous bugs 2003-12-19 05:00:00 UTC
Red Hat Product Errata RHBA-2003:361 normal SHIPPED_LIVE New strace package fixes numerous bugs 2003-11-18 05:00:00 UTC

Description Mike Gahagan 2002-12-23 16:29:05 UTC
Description of problem:


Strace -f will break with programs that use the wait4 system call (aka waitpid
or wait3) with the WNOHANG flag when they have live children.

Version-Release number of selected component (if applicable):

strace-4.3-2 (comes with AS 2.1)
strace-4.4cvs20021217rh-1
(problem exists w/ 7.x and 8.0)

How reproducible:

Always. AT&T's ksh is a reliable reproducer.

Steps to Reproduce:
1.Install AT&T ksh and any version of strace from above.
2.Run attached test script.
3.
    
Actual results:

See attached

Expected results:

strace should be able to follow processes.

Additional info:

Comment 1 Mike Gahagan 2002-12-23 16:32:10 UTC
AT&T's ksh93 is available from www.kornshell.com

Comment 2 Mike Gahagan 2002-12-23 16:33:16 UTC
Created attachment 88867 [details]
tarball of strace output and ksh test script.

Comment 3 Mike Gahagan 2002-12-23 18:07:42 UTC
Created attachment 88868 [details]
strace-4.4.cvs20021221rh-1 on 8.0

same failure as before

Comment 4 Mike Gahagan 2002-12-23 18:09:35 UTC
Created attachment 88869 [details]
tarball showing failure with strace-4.4.cvs20021221rh-1

Comment 5 Roland McGrath 2002-12-27 01:40:03 UTC
I am confused.  There is no sign of the bug in the attachments here.
The failure mode before was that strace interfered with the normal functioning
of ksh, indicated by the "Warning: error(s) creating ..." message produced from
the script.  Those messages do not appear in your transcripts attached here.
Please state explicitly for the record what criteria you are applying when
you say that there is still a bug here.  

Comment 6 Roland McGrath 2003-01-10 23:07:04 UTC
Version 4.4.91-1 should work fine.


Comment 7 John Flanagan 2003-12-19 17:57:54 UTC
An errata has been issued which should help the problem described in this bug report. 
This report is therefore being closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files, please follow the link below. You may reopen 
this bug report if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2003-294.html



Note You need to log in before you can comment on or make changes to this bug.